package com.yunzhupaas.mdm.controller;


import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import com.yunzhupaas.base.ActionResult;
import com.yunzhupaas.base.UserInfo;
import com.yunzhupaas.exception.DataException;
import com.yunzhupaas.permission.entity.UserEntity;
import com.yunzhupaas.constant.MsgCode;
import com.yunzhupaas.mdm.service.*;
import com.yunzhupaas.mdm.entity.*;
import com.yunzhupaas.util.*;
import com.yunzhupaas.mdm.model.worktype.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import com.yunzhupaas.flowable.entity.TaskEntity;
import jakarta.validation.Valid;
import java.util.*;
import com.yunzhupaas.model.ExcelModel;
import com.yunzhupaas.excel.ExcelExportStyler;
import com.yunzhupaas.excel.ExcelHelper;
import com.yunzhupaas.annotation.YunzhupaasField;
import com.yunzhupaas.base.vo.PageListVO;
import com.yunzhupaas.base.vo.PaginationVO;
import com.yunzhupaas.base.vo.DownloadVO;
import com.yunzhupaas.config.ConfigValueUtil;
import com.yunzhupaas.base.entity.ProvinceEntity;
import java.io.IOException;
import java.util.stream.Collectors;
import com.yunzhupaas.flowable.entity.TaskEntity;
import com.yunzhupaas.exception.WorkFlowException;
import com.yunzhupaas.model.visualJson.UploaderTemplateModel;
import com.yunzhupaas.base.util.FormExecelUtils;
import org.springframework.web.multipart.MultipartFile;
import cn.afterturn.easypoi.excel.ExcelExportUtil;
import cn.afterturn.easypoi.excel.ExcelImportUtil;
import cn.afterturn.easypoi.excel.entity.ExportParams;
import cn.afterturn.easypoi.excel.entity.ImportParams;
import cn.afterturn.easypoi.excel.entity.params.ExcelExportEntity;
import cn.afterturn.easypoi.excel.entity.enmus.ExcelType;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Workbook;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import com.yunzhupaas.onlinedev.model.ExcelImFieldModel;
import com.yunzhupaas.base.model.OnlineImport.ImportDataModel;
import com.yunzhupaas.base.model.OnlineImport.ImportFormCheckUniqueModel;
import com.yunzhupaas.base.model.OnlineImport.ExcelImportModel;
import com.yunzhupaas.base.model.OnlineImport.VisualImportModel;
import cn.xuyanwu.spring.file.storage.FileInfo;
import lombok.Cleanup;
import com.yunzhupaas.model.visualJson.config.HeaderModel;
import com.yunzhupaas.base.model.ColumnDataModel;
import com.yunzhupaas.base.util.VisualUtils;
import org.springframework.transaction.annotation.Transactional;

/**
 * 工种信息
 * @版本： V5.2.7
 * @版权： Copyright @ 2025  深圳市乐程软件有限公司版权所有
 * @作者： 深圳市乐程软件有限公司
 * @日期： 2026-05-18
 */
@Slf4j
@RestController
@Tag(name = "工种信息" , description = "2")
@RequestMapping("/api/bcm/WorkType")
public class WorkTypeController {

    @Autowired
    private GeneraterSwapUtil generaterSwapUtil;

    @Autowired
    private UserProvider userProvider;

    @Autowired
    private WorkTypeService workTypeService;



    @Autowired
    private ConfigValueUtil configValueUtil;

    /**
    * 列表
    *
    * @param workTypePagination
    * @return
    */
    @Operation(summary = "获取列表")
    @PostMapping("/getList")
    public ActionResult list(@RequestBody WorkTypePagination workTypePagination)throws Exception{
        List<WorkTypeEntity> list= workTypeService.getList(workTypePagination);
        List<Map<String, Object>> realList=new ArrayList<>();
        for (WorkTypeEntity entity : list) {
        Map<String, Object> workTypeMap=JsonUtil.entityToMap(entity);
        workTypeMap.put("id", workTypeMap.get("work_type_id"));
        //副表数据
        //子表数据
            realList.add(workTypeMap);
        }
        //数据转换
        boolean isPc = "pc".equals(ServletUtil.getHeader("yunzhupaas-origin" ));
        realList = generaterSwapUtil.swapDataList(realList, WorkTypeConstant.getFormData(), WorkTypeConstant.getColumnData(), workTypePagination.getModuleId(),isPc?false:false);

        //返回对象
        PageListVO vo = new PageListVO();
        vo.setList(realList);
        PaginationVO page = JsonUtil.getJsonToBean(workTypePagination, PaginationVO.class);
        vo.setPagination(page);
        return ActionResult.success(vo);
    }
    /**
    * 创建
    *
    * @param workTypeForm
    * @return
    */
    @PostMapping()
    @Operation(summary = "创建")
    public ActionResult create(@RequestBody @Valid WorkTypeForm workTypeForm) {
        String b = workTypeService.checkForm(workTypeForm,0);
        if (StringUtil.isNotEmpty(b)){
            return ActionResult.fail(b );
        }
        try{
            workTypeService.saveOrUpdate(workTypeForm, null ,true);
        }catch(Exception e){
            return ActionResult.fail(MsgCode.FA028.get());
        }
        return ActionResult.success(MsgCode.SU001.get());
    }
    /**
    * 导出Excel
    *
    * @return
    */
    @Operation(summary = "导出Excel")
    @PostMapping("/Actions/Export")
    public ActionResult Export(@RequestBody WorkTypePagination workTypePagination) throws IOException {
        if (StringUtil.isEmpty(workTypePagination.getSelectKey())){
            return ActionResult.fail(MsgCode.IMP011.get());
        }
        List<WorkTypeEntity> list= workTypeService.getList(workTypePagination);
        List<Map<String, Object>> realList=new ArrayList<>();
        for (WorkTypeEntity entity : list) {
        Map<String, Object> workTypeMap=JsonUtil.entityToMap(entity);
        workTypeMap.put("id", workTypeMap.get("work_type_id"));
        //副表数据
        //子表数据
            realList.add(workTypeMap);
        }
        //数据转换
        realList = generaterSwapUtil.swapDataList(realList, WorkTypeConstant.getFormData(), WorkTypeConstant.getColumnData(), workTypePagination.getModuleId(),false);
        String[]keys=!StringUtil.isEmpty(workTypePagination.getSelectKey())?workTypePagination.getSelectKey():new String[0];
        UserInfo userInfo=userProvider.get();
        String menuFullName = generaterSwapUtil.getMenuName(workTypePagination.getMenuId());

            DownloadVO vo=this.creatModelExcel(configValueUtil.getTemporaryFilePath(),realList,keys,userInfo,menuFullName);
        return ActionResult.success(vo);
    }

    /**
    * 导出表格方法
    */
    public DownloadVO creatModelExcel(String path,List<Map<String, Object>>list,String[]keys,UserInfo userInfo,String menuFullName){
        DownloadVO vo=DownloadVO.builder().build();
        List<ExcelExportEntity> entitys=new ArrayList<>();
        if(keys.length>0){
            for(String key:keys){
                switch(key){
                    case "work_type_code" :
                    entitys.add(new ExcelExportEntity("工种编码" ,"work_type_code"));
                    break;
                    case "work_type_name" :
                    entitys.add(new ExcelExportEntity("工种名称" ,"work_type_name"));
                    break;
                    case "work_category_id" :
                    entitys.add(new ExcelExportEntity("工种分类" ,"work_category_id"));
                    break;
                    case "skill_level" :
                    entitys.add(new ExcelExportEntity("技能等级" ,"skill_level"));
                    break;
                    case "unit" :
                    entitys.add(new ExcelExportEntity("计价单位" ,"unit"));
                    break;
                    case "reference_unit_price" :
                    entitys.add(new ExcelExportEntity("参考单价" ,"reference_unit_price"));
                    break;
                    case "price_lower_limit" :
                    entitys.add(new ExcelExportEntity("单价下限" ,"price_lower_limit"));
                    break;
                    case "price_upper_limit" :
                    entitys.add(new ExcelExportEntity("单价上限" ,"price_upper_limit"));
                    break;
                    case "seq_num" :
                    entitys.add(new ExcelExportEntity("排序号" ,"seq_num"));
                    break;
                    case "work_description" :
                    entitys.add(new ExcelExportEntity("工种描述" ,"work_description"));
                    break;
                    case "remarks" :
                    entitys.add(new ExcelExportEntity("备注" ,"remarks"));
                    break;
                    default:
                    break;
                }
            }
        }

        ExportParams exportParams = new ExportParams(null, "表单信息");
        exportParams.setType(ExcelType.XSSF);
        try{
            @Cleanup Workbook workbook = new HSSFWorkbook();
            if (entitys.size()>0){
                if (list.size()==0){
                    list.add(new HashMap<>());
                }
                //去除空数据
                List<Map<String, Object>> dataList = new ArrayList<>();
                for (Map<String, Object> map : list) {
                    int i = 0;
                    for (String key : keys) {
                        //子表
                        if (key.toLowerCase().startsWith("tablefield")) {
                            String tableField = key.substring(0, key.indexOf("-" ));
                            String field = key.substring(key.indexOf("-" ) + 1);
                            Object o = map.get(tableField);
                            if (o != null) {
                                List<Map<String, Object>> childList = (List<Map<String, Object>>) o;
                                for (Map<String, Object> childMap : childList) {
                                    if (childMap.get(field) != null) {
                                        i++;
                                    }
                                }
                            }
                        } else {
                            Object o = map.get(key);
                            if (o != null) {
                                i++;
                            }
                        }
                    }
                    if (i > 0) {
                        dataList.add(map);
                    }
                }
                List<ExcelExportEntity> mergerEntitys = new ArrayList<>(entitys);
                List<Map<String, Object>> mergerList=new ArrayList<>(dataList);
                //复杂表头-表头和数据处理
                ColumnDataModel columnDataModel = JsonUtil.getJsonToBean(WorkTypeConstant.getColumnData(), ColumnDataModel.class);
                List<HeaderModel> complexHeaderList = columnDataModel.getComplexHeaderList();
                if (!Objects.equals(columnDataModel.getType(), 3) && !Objects.equals(columnDataModel.getType(), 5)) {
                    entitys = VisualUtils.complexHeaderHandel(entitys, complexHeaderList, Objects.equals(columnDataModel.getType(), 4));
                    dataList =  VisualUtils.complexHeaderDataHandel(dataList, complexHeaderList, Objects.equals(columnDataModel.getType(), 4));
                }

                exportParams.setStyle(ExcelExportStyler.class);
                workbook = ExcelExportUtil.exportExcel(exportParams, entitys, dataList);
                VisualUtils.mergerVertical(workbook, mergerEntitys, mergerList);
                ExcelModel excelModel = generaterSwapUtil.getExcelParams(WorkTypeConstant.getFormData(),Arrays.asList(keys));
                ExcelHelper helper = new ExcelHelper();
                helper.init(workbook, exportParams, entitys, excelModel);
                helper.doPreHandle();
                helper.doPostHandle();
            }
            String fileName = menuFullName  +"_"+ DateUtil.dateNow("yyyyMMddHHmmss") + ".xls";
            MultipartFile multipartFile = ExcelUtil.workbookToCommonsMultipartFile(workbook, fileName);
            String temporaryFilePath = configValueUtil.getTemporaryFilePath();
            FileInfo fileInfo = FileUploadUtils.uploadFile(multipartFile, temporaryFilePath, fileName);
            vo.setName(fileInfo.getFilename());
            vo.setUrl(UploaderUtil.uploaderFile(fileInfo.getFilename() + "#" + "Temporary") + "&name=" + fileName);
        } catch (Exception e) {
            log.error("信息导出Excel错误:{}", e.getMessage());
            e.printStackTrace();
        }
        return vo;
    }
    @Operation(summary = "上传文件")
    @PostMapping("/Uploader")
    public ActionResult<Object> Uploader() {
        List<MultipartFile> list = UpUtil.getFileAll();
        MultipartFile file = list.get(0);
        if (file.getOriginalFilename().endsWith(".xlsx") || file.getOriginalFilename().endsWith(".xls")) {
            String filePath = XSSEscape.escape(configValueUtil.getTemporaryFilePath());
            String fileName = XSSEscape.escape(RandomUtil.uuId() + "." + UpUtil.getFileType(file));
            //上传文件
            FileInfo fileInfo = FileUploadUtils.uploadFile(file, filePath, fileName);
            DownloadVO vo = DownloadVO.builder().build();
            vo.setName(fileInfo.getFilename());
            return ActionResult.success(vo);
        } else {
            return ActionResult.fail(MsgCode.FA017.get());
        }
    }

    /**
    * 模板下载
    *
    * @return
    */
    @Operation(summary = "模板下载")
    @GetMapping("/TemplateDownload")
    public ActionResult<DownloadVO>  TemplateDownload(@RequestParam("menuId") String menuId){
        DownloadVO vo = DownloadVO.builder().build();
        UserInfo userInfo = userProvider.get();
        String menuFullName = generaterSwapUtil.getMenuName(menuId);
        //主表对象
        List<ExcelExportEntity> entitys = new ArrayList<>();
        List<String> selectKeys = new ArrayList<>();
        //以下添加字段
                entitys.add(new ExcelExportEntity("工种名称(work_type_name)" ,"work_type_name"));
                selectKeys.add("work_type_name");
                entitys.add(new ExcelExportEntity("工种分类(work_category_id)" ,"work_category_id"));
                selectKeys.add("work_category_id");
                entitys.add(new ExcelExportEntity("技能等级(skill_level)" ,"skill_level"));
                selectKeys.add("skill_level");
                entitys.add(new ExcelExportEntity("计价单位(unit)" ,"unit"));
                selectKeys.add("unit");
                entitys.add(new ExcelExportEntity("参考单价(reference_unit_price)" ,"reference_unit_price"));
                selectKeys.add("reference_unit_price");
                entitys.add(new ExcelExportEntity("单价下限(price_lower_limit)" ,"price_lower_limit"));
                selectKeys.add("price_lower_limit");
                entitys.add(new ExcelExportEntity("单价上限(price_upper_limit)" ,"price_upper_limit"));
                selectKeys.add("price_upper_limit");
                entitys.add(new ExcelExportEntity("排序号(seq_num)" ,"seq_num"));
                selectKeys.add("seq_num");
                entitys.add(new ExcelExportEntity("工种描述(work_description)" ,"work_description"));
                selectKeys.add("work_description");
                entitys.add(new ExcelExportEntity("备注(remarks)" ,"remarks"));
                selectKeys.add("remarks");
        ExcelModel excelModel = generaterSwapUtil.getExcelParams(WorkTypeConstant.getFormData(),selectKeys);
        List<Map<String, Object>> list = new ArrayList<>();
        list.add(excelModel.getDataMap());

        ExportParams exportParams = new ExportParams(null, menuFullName + "模板");
        exportParams.setStyle(ExcelExportStyler.class);
        exportParams.setType(ExcelType.XSSF);
        try{
        @Cleanup Workbook workbook = new HSSFWorkbook();
        if (entitys.size()>0){
            if (list.size()==0){
                list.add(new HashMap<>());
            }
            //复杂表头-表头和数据处理
            ColumnDataModel columnDataModel = JsonUtil.getJsonToBean(WorkTypeConstant.getColumnData(), ColumnDataModel.class);
            List<HeaderModel> complexHeaderList = columnDataModel.getComplexHeaderList();
            if (!Objects.equals(columnDataModel.getType(), 3) && !Objects.equals(columnDataModel.getType(), 5)) {
                entitys = VisualUtils.complexHeaderHandel(entitys, complexHeaderList, false);
                list =  VisualUtils.complexHeaderDataHandel(list, complexHeaderList, false);
            }
            workbook = ExcelExportUtil.exportExcel(exportParams, entitys, list);
            ExcelHelper helper = new ExcelHelper();
            helper.init(workbook, exportParams, entitys, excelModel);
            helper.doPreHandle();
            helper.doPostHandle();
        }
        String fileName = menuFullName + "导入模板.xls";
        MultipartFile multipartFile = ExcelUtil.workbookToCommonsMultipartFile(workbook, fileName);
            String temporaryFilePath = configValueUtil.getTemporaryFilePath();
            FileInfo fileInfo = FileUploadUtils.uploadFile(multipartFile, temporaryFilePath, fileName);
        vo.setName(fileInfo.getFilename());
        vo.setUrl(UploaderUtil.uploaderFile(fileInfo.getFilename() + "#" + "Temporary") + "&name=" + fileName);
        } catch (Exception e) {
        log.error("模板信息导出Excel错误:{}", e.getMessage());
        e.printStackTrace();
        }
        return ActionResult.success(vo);
    }

    /**
    * 导入预览
    *
    * @return
    */
    @Operation(summary = "导入预览" )
    @GetMapping("/ImportPreview")
    public ActionResult<Map<String, Object>> ImportPreview(String fileName) throws Exception {
        Map<String, Object> headAndDataMap = new HashMap<>(2);
            String filePath = FileUploadUtils.getLocalBasePath() + configValueUtil.getTemporaryFilePath();
            FileUploadUtils.downLocal(configValueUtil.getTemporaryFilePath(), filePath, fileName);
        File temporary = new File(XSSEscape.escapePath(filePath + fileName));
            int headerRowIndex = 1;
        ImportParams params = new ImportParams();
        params.setTitleRows(0);
        params.setHeadRows(headerRowIndex);
        params.setNeedVerify(true);
        try {
            InputStream inputStream = ExcelUtil.solveOrginTitle(temporary, headerRowIndex);
            List<Map> excelDataList = ExcelUtil.importExcelByInputStream(inputStream, 0, headerRowIndex, Map.class);
            //数据超过1000条
            if(excelDataList != null && excelDataList.size() > 1000) {
                return ActionResult.fail(MsgCode.ETD117.get());
            }

            ColumnDataModel columnDataModel = JsonUtil.getJsonToBean(WorkTypeConstant.getColumnData(), ColumnDataModel.class);
            UploaderTemplateModel uploaderTemplateModel = JsonUtil.getJsonToBean(columnDataModel.getUploaderTemplateJson(), UploaderTemplateModel.class);
            List<String> selectKey = uploaderTemplateModel.getSelectKey();
            //子表合并
            List<Map<String, Object>> results = FormExecelUtils.dataMergeChildTable(excelDataList,selectKey);
            // 导入字段
            List<ExcelImFieldModel> columns = new ArrayList<>();
            columns.add(new ExcelImFieldModel("work_type_name","工种名称","input"));
            columns.add(new ExcelImFieldModel("work_category_id","工种分类","select"));
            columns.add(new ExcelImFieldModel("skill_level","技能等级","select"));
            columns.add(new ExcelImFieldModel("unit","计价单位","input"));
            columns.add(new ExcelImFieldModel("reference_unit_price","参考单价","inputNumber"));
            columns.add(new ExcelImFieldModel("price_lower_limit","单价下限","inputNumber"));
            columns.add(new ExcelImFieldModel("price_upper_limit","单价上限","inputNumber"));
            columns.add(new ExcelImFieldModel("seq_num","排序号","inputNumber"));
            columns.add(new ExcelImFieldModel("work_description","工种描述","textarea"));
            columns.add(new ExcelImFieldModel("remarks","备注","textarea"));
            headAndDataMap.put("dataRow" , results);
            headAndDataMap.put("headerRow" , JsonUtil.getJsonToList(JsonUtil.getListToJsonArray(columns)));
            } catch (Exception e){
            e.printStackTrace();
            return ActionResult.fail(MsgCode.VS407.get());
        }
        return ActionResult.success(headAndDataMap);
    }

    /**
    * 导入数据
    *
    * @return
    */
    @Operation(summary = "导入数据" )
    @PostMapping("/ImportData")
    public ActionResult<ExcelImportModel> ImportData(@RequestBody VisualImportModel visualImportModel) throws Exception {
        List<Map<String, Object>> listData = visualImportModel.getList();
        ImportFormCheckUniqueModel uniqueModel = new ImportFormCheckUniqueModel();
        uniqueModel.setDbLinkId(WorkTypeConstant.DBLINKID);
        uniqueModel.setUpdate(Objects.equals("1", "2"));

        Map<String,String> tablefieldkey = new HashMap<>();
        for(String key:WorkTypeConstant.TABLEFIELDKEY.keySet()){
        tablefieldkey.put(key,WorkTypeConstant.TABLERENAMES.get(WorkTypeConstant.TABLEFIELDKEY.get(key)));
        }
        ExcelImportModel excelImportModel = generaterSwapUtil.importData(WorkTypeConstant.getFormData(),listData,uniqueModel, tablefieldkey,WorkTypeConstant.getTableList());
        List<ImportDataModel> importDataModel = uniqueModel.getImportDataModel();
        for (ImportDataModel model : importDataModel) {
            String id = model.getId();
            Map<String, Object> result = model.getResultData();
            if(StringUtil.isNotEmpty(id)){
                update(id, JsonUtil.getJsonToBean(result,WorkTypeForm.class), true);
            }else {
                create( JsonUtil.getJsonToBean(result,WorkTypeForm.class));
            }
        }
        return ActionResult.success(excelImportModel);
    }

    /**
    * 导出异常报告
    *
    * @return
    */
    @Operation(summary = "导出异常报告")
    @PostMapping("/ImportExceptionData")
    public ActionResult<DownloadVO> ImportExceptionData(@RequestBody VisualImportModel visualImportModel) {
        DownloadVO vo = DownloadVO.builder().build();
        UserInfo userInfo = userProvider.get();
        String menuFullName = generaterSwapUtil.getMenuName(visualImportModel.getMenuId());
        //主表对象
        List<ExcelExportEntity> entitys = new ArrayList<>();
        entitys.add(new ExcelExportEntity("异常原因", "errorsInfo",30));
        List<String> selectKeys = new ArrayList<>();
        //以下添加字段
                entitys.add(new ExcelExportEntity("工种名称(work_type_name)" ,"work_type_name"));
                selectKeys.add("work_type_name");
                entitys.add(new ExcelExportEntity("工种分类(work_category_id)" ,"work_category_id"));
                selectKeys.add("work_category_id");
                entitys.add(new ExcelExportEntity("技能等级(skill_level)" ,"skill_level"));
                selectKeys.add("skill_level");
                entitys.add(new ExcelExportEntity("计价单位(unit)" ,"unit"));
                selectKeys.add("unit");
                entitys.add(new ExcelExportEntity("参考单价(reference_unit_price)" ,"reference_unit_price"));
                selectKeys.add("reference_unit_price");
                entitys.add(new ExcelExportEntity("单价下限(price_lower_limit)" ,"price_lower_limit"));
                selectKeys.add("price_lower_limit");
                entitys.add(new ExcelExportEntity("单价上限(price_upper_limit)" ,"price_upper_limit"));
                selectKeys.add("price_upper_limit");
                entitys.add(new ExcelExportEntity("排序号(seq_num)" ,"seq_num"));
                selectKeys.add("seq_num");
                entitys.add(new ExcelExportEntity("工种描述(work_description)" ,"work_description"));
                selectKeys.add("work_description");
                entitys.add(new ExcelExportEntity("备注(remarks)" ,"remarks"));
                selectKeys.add("remarks");
        ExcelModel excelModel = generaterSwapUtil.getExcelParams(WorkTypeConstant.getFormData(),selectKeys);
        List<Map<String, Object>> list = new ArrayList<>();
        list.addAll(visualImportModel.getList());

        ExportParams exportParams = new ExportParams(null, menuFullName + "模板");
        exportParams.setStyle(ExcelExportStyler.class);
        exportParams.setType(ExcelType.XSSF);
        exportParams.setFreezeCol(1);
        try{
            @Cleanup Workbook workbook = new HSSFWorkbook();
            if (entitys.size()>0){
                if (list.size()==0){
                    list.add(new HashMap<>());
                }
                //复杂表头-表头和数据处理
                ColumnDataModel columnDataModel = JsonUtil.getJsonToBean(WorkTypeConstant.getColumnData(), ColumnDataModel.class);
                List<HeaderModel> complexHeaderList = columnDataModel.getComplexHeaderList();
                if (!Objects.equals(columnDataModel.getType(), 3) && !Objects.equals(columnDataModel.getType(), 5)) {
                    entitys = VisualUtils.complexHeaderHandel(entitys, complexHeaderList, false);
                    list =  VisualUtils.complexHeaderDataHandel(list, complexHeaderList, false);
                }

                workbook = ExcelExportUtil.exportExcel(exportParams, entitys, list);
                ExcelHelper helper = new ExcelHelper();
                helper.init(workbook, exportParams, entitys, excelModel);
                helper.doPreHandle();
                helper.doPostHandle();
            }

            String fileName = menuFullName + "错误报告_" + DateUtil.dateNow("yyyyMMddHHmmss") + ".xls";
            MultipartFile multipartFile = ExcelUtil.workbookToCommonsMultipartFile(workbook, fileName);
            String temporaryFilePath = configValueUtil.getTemporaryFilePath();
            FileInfo fileInfo = FileUploadUtils.uploadFile(multipartFile, temporaryFilePath, fileName);
            vo.setName(fileInfo.getFilename());
            vo.setUrl(UploaderUtil.uploaderFile(fileInfo.getFilename() + "#" + "Temporary") + "&name=" + fileName);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return ActionResult.success(vo);
    }
    /**
    * 删除
    * @param id
    * @return
    */
    @Operation(summary = "删除")
    @DeleteMapping("/{id}")
    @Transactional
    public ActionResult delete(@PathVariable("id") String id,@RequestParam(name = "forceDel",defaultValue = "false") boolean forceDel) throws Exception{
        WorkTypeEntity entity= workTypeService.getInfo(id);
        if(entity!=null){
            //假删除
            entity.setDeleteMark(1);
            entity.setDeleteUserId(userProvider.get().getUserId());
            entity.setDeleteTime(new Date());
            workTypeService.setIgnoreLogicDelete().updateById(entity);
        }
        return ActionResult.success(MsgCode.SU003.get());
    }
    /**
    * 批量删除
    * @param obj
    * @return
    */
    @DeleteMapping("/batchRemove")
    @Transactional
    @Operation(summary = "批量删除")
    public ActionResult batchRemove(@RequestBody Object obj){
    Map<String, Object> objectMap = JsonUtil.entityToMap(obj);
    List<String> idList = JsonUtil.getJsonToList(objectMap.get("ids"), String.class);
    String errInfo = "";
    List<String> successList = new ArrayList<>();
        for (String allId : idList){
            try {
                this.delete(allId,false);
                successList.add(allId);
            } catch (Exception e) {
                errInfo = e.getMessage();
            }
        }
        if (successList.size() == 0 && StringUtil.isNotEmpty(errInfo)){
            return ActionResult.fail(errInfo);
        }
        return ActionResult.success(MsgCode.SU003.get());
    }
    /**
    * 编辑
    * @param id
    * @param workTypeForm
    * @return
    */
    @PutMapping("/{id}")
    @Operation(summary = "更新")
    public ActionResult update(@PathVariable("id") String id,@RequestBody @Valid WorkTypeForm workTypeForm,
                                @RequestParam(value = "isImport", required = false) boolean isImport){
        WorkTypeEntity entity= workTypeService.getInfo(id);
        if(entity!=null){
            workTypeForm.setWorkTypeId(String.valueOf(entity.getWorkTypeId()));

            if (!isImport) {
                String b =  workTypeService.checkForm(workTypeForm,1);
                if (StringUtil.isNotEmpty(b)){
                    return ActionResult.fail(b );
                }
            }

            try{
                workTypeService.saveOrUpdate(workTypeForm,id,false);
            }catch (DataException e1){
                return ActionResult.fail(e1.getMessage());
            }catch(Exception e){
                return ActionResult.fail(MsgCode.FA029.get());
            }
            return ActionResult.success(MsgCode.SU004.get());
        }else{
            return ActionResult.fail(MsgCode.FA002.get());
        }
    }
    /**
    * 表单信息(详情页)
    * 详情页面使用-转换数据
    * @param id
    * @return
    */
    @Operation(summary = "表单信息(详情页)")
    @GetMapping("/detail/{id}")
    public ActionResult detailInfo(@PathVariable("id") String id){
        WorkTypeEntity entity= workTypeService.getInfo(id);
        if(entity==null){
            return ActionResult.fail(MsgCode.FA001.get());
        }
        Map<String, Object> workTypeMap=JsonUtil.entityToMap(entity);
        workTypeMap.put("id", workTypeMap.get("work_type_id"));
        //副表数据
        //子表数据
        boolean isPc = "pc".equals(ServletUtil.getHeader("yunzhupaas-origin" ));
        workTypeMap = generaterSwapUtil.swapDataDetail(workTypeMap,WorkTypeConstant.getFormData(),"823446652726543365",isPc?false:false);
        //子表数据
        return ActionResult.success(workTypeMap);
    }
    /**
    * 获取详情(编辑页)
    * 编辑页面使用-不转换数据
    * @param id
    * @return
    */
    @Operation(summary = "信息")
    @GetMapping("/{id}")
    public ActionResult info(@PathVariable("id") String id){
        WorkTypeEntity entity= workTypeService.getInfo(id);
        if(entity==null){
            return ActionResult.fail(MsgCode.FA001.get());
        }
        Map<String, Object> workTypeMap=JsonUtil.entityToMap(entity);
        workTypeMap.put("id", workTypeMap.get("work_type_id"));
        //副表数据
        //子表数据
        workTypeMap = generaterSwapUtil.swapDataForm(workTypeMap,WorkTypeConstant.getFormData(),WorkTypeConstant.TABLEFIELDKEY,WorkTypeConstant.TABLERENAMES);
        return ActionResult.success(workTypeMap);
    }

}
